submodule: clean up substitutions in script
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
70c7ac22 45
be9d0a3a
HV
46die_if_unmatched ()
47{
48 if test "$1" = "#unmatched"
49 then
c4c02bf1 50 exit ${2:-1}
be9d0a3a
HV
51 fi
52}
53
88ce00c3
TK
54#
55# Print a submodule configuration setting
56#
57# $1 = submodule name
58# $2 = option name
59# $3 = default value
60#
61# Checks in the usual git-config places first (for overrides),
62# otherwise it falls back on .gitmodules. This allows you to
63# distribute project-wide defaults in .gitmodules, while still
64# customizing individual repositories if necessary. If the option is
65# not in .gitmodules either, print a default value.
66#
67get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
75 fi
76 printf '%s' "${value:-$default}"
77}
78
862ae6cd
RS
79isnumber()
80{
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82}
83
14111fc4
JK
84# Sanitize the local git environment for use within a submodule. We
85# can't simply use clear_local_git_env since we want to preserve some
86# of the settings from GIT_CONFIG_PARAMETERS.
87sanitize_submodule_env()
88{
89044baa 89 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 90 clear_local_git_env
89044baa 91 GIT_CONFIG_PARAMETERS=$save_config
860cba61 92 export GIT_CONFIG_PARAMETERS
14111fc4
JK
93}
94
ecda0723
SV
95#
96# Add a new submodule to the working tree, .gitmodules and the index
97#
ec05df35 98# $@ = repo path
ecda0723
SV
99#
100# optional branch is stored in global branch variable
101#
23a485e3 102cmd_add()
ecda0723 103{
5c08dbbd 104 # parse $args after "submodule ... add".
091a6eb0 105 reference_path=
5c08dbbd
JH
106 while test $# -ne 0
107 do
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
113 ;;
d27b876b
JL
114 -f | --force)
115 force=$1
116 ;;
5c08dbbd 117 -q|--quiet)
2e6a30ef 118 GIT_QUIET=1
5c08dbbd 119 ;;
d92a3959
MT
120 --reference)
121 case "$2" in '') usage ;; esac
091a6eb0 122 reference_path=$2
d92a3959
MT
123 shift
124 ;;
125 --reference=*)
091a6eb0 126 reference_path="${1#--reference=}"
d92a3959 127 ;;
73b0898d
JL
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
132 ;;
275cd184
FG
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
137 ;;
138 --depth=*)
139 depth=$1
140 ;;
5c08dbbd
JH
141 --)
142 shift
143 break
144 ;;
145 -*)
146 usage
147 ;;
148 *)
149 break
150 ;;
151 esac
152 shift
153 done
154
091a6eb0
JK
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
159
160 reference="--reference=$reference_path"
161 fi
162
ecda0723 163 repo=$1
64394e3a 164 sm_path=$2
ecda0723 165
64394e3a 166 if test -z "$sm_path"; then
6a066230 167 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169 fi
170
496eeeb1 171 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
172 usage
173 fi
174
091a6eb0
JK
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
ec05df35
ML
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
091a6eb0
JK
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
ec05df35 183 # dereference source url relative to parent's url
63e95beb 184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
185 ;;
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
189 ;;
190 *)
497ee872 191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
192 ;;
193 esac
194
db75ada5
MG
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
64394e3a 197 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
8196e728 201 s|/\(\./\)*|/|g
db75ada5
MG
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
206 ')
619acfc7
SB
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214 fi
ecda0723 215
53213994
JK
216 if test -z "$force" &&
217 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 218 then
6ff875c5 219 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 220\$sm_path
6ff875c5 221Use -f if you really want to add it." >&2
d27b876b
JL
222 exit 1
223 fi
224
73b0898d
JL
225 if test -n "$custom_name"
226 then
227 sm_name="$custom_name"
228 else
229 sm_name="$sm_path"
230 fi
231
d4264ca3 232 # perhaps the path exists and is already a git repo, else clone it
64394e3a 233 if test -e "$sm_path"
d4264ca3 234 then
496eeeb1 235 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 236 then
64394e3a 237 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 238 else
64394e3a 239 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 240 fi
c2f93917 241
d4264ca3 242 else
4b7c286e
JL
243 if test -d ".git/modules/$sm_name"
244 then
245 if test -z "$force"
246 then
0d71dbfd 247 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 248 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
249 die "$(eval_gettextln "\
250If you want to reuse this local git directory instead of cloning again from
251 \$realrepo
252use the '--force' option. If the local git directory is not the correct repo
253or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 254 else
0d71dbfd 255 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
256 fi
257 fi
d10e3b42 258 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 259 (
14111fc4 260 sanitize_submodule_env
d851ffb9
JH
261 cd "$sm_path" &&
262 # ash fails to wordsplit ${branch:+-b "$branch"...}
263 case "$branch" in
264 '') git checkout -f -q ;;
265 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
266 esac
267 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 268 fi
73b0898d 269 git config submodule."$sm_name".url "$realrepo"
d4264ca3 270
53213994 271 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 272 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 273
73b0898d
JL
274 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
275 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
276 if test -n "$branch"
277 then
278 git config -f .gitmodules submodule."$sm_name".branch "$branch"
279 fi &&
31991b02 280 git add --force .gitmodules ||
64394e3a 281 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
282
283 # NEEDSWORK: In a multi-working-tree world, this needs to be
284 # set in the per-worktree config.
285 if git config --get submodule.active >/dev/null
286 then
287 # If the submodule being adding isn't already covered by the
288 # current configured pathspec, set the submodule's active flag
289 if ! git submodule--helper is-active "$sm_path"
290 then
291 git config submodule."$sm_name".active "true"
292 fi
293 else
294 git config submodule."$sm_name".active "true"
295 fi
ecda0723
SV
296}
297
19a31f9c
ML
298#
299# Execute an arbitrary command sequence in each checked out
300# submodule
301#
302# $@ = command to execute
303#
304cmd_foreach()
305{
1d5bec8b
JH
306 # parse $args after "submodule ... foreach".
307 while test $# -ne 0
308 do
309 case "$1" in
310 -q|--quiet)
311 GIT_QUIET=1
312 ;;
15fc56a8
JH
313 --recursive)
314 recursive=1
315 ;;
1d5bec8b
JH
316 -*)
317 usage
318 ;;
319 *)
320 break
321 ;;
322 esac
323 shift
324 done
325
f030c96d
ÆAB
326 toplevel=$(pwd)
327
4dca1aa6
BC
328 # dup stdin so that it can be restored when running the external
329 # command in the subshell (and a recursive call to this function)
330 exec 3<&0
331
b0f4b408
SB
332 {
333 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 334 echo "#unmatched" $?
b0f4b408 335 } |
cf9e55f4 336 while read -r mode sha1 stage sm_path
19a31f9c 337 do
c4c02bf1 338 die_if_unmatched "$mode" "$sha1"
64394e3a 339 if test -e "$sm_path"/.git
19a31f9c 340 then
44431df0 341 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 342 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 343 name=$(git submodule--helper name "$sm_path")
15fc56a8 344 (
64394e3a 345 prefix="$prefix$sm_path/"
14111fc4 346 sanitize_submodule_env
64394e3a 347 cd "$sm_path" &&
44431df0 348 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
349 # we make $path available to scripts ...
350 path=$sm_path &&
1c4fb136
AK
351 if test $# -eq 1
352 then
353 eval "$1"
354 else
355 "$@"
356 fi &&
15fc56a8
JH
357 if test -n "$recursive"
358 then
359 cmd_foreach "--recursive" "$@"
360 fi
4dca1aa6 361 ) <&3 3<&- ||
ea2fa104 362 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
363 fi
364 done
365}
366
70c7ac22 367#
211b7f19 368# Register submodules in .git/config
70c7ac22
LH
369#
370# $@ = requested paths (default to all)
371#
23a485e3 372cmd_init()
70c7ac22 373{
5c08dbbd
JH
374 # parse $args after "submodule ... init".
375 while test $# -ne 0
376 do
377 case "$1" in
378 -q|--quiet)
2e6a30ef 379 GIT_QUIET=1
5c08dbbd
JH
380 ;;
381 --)
382 shift
383 break
384 ;;
385 -*)
386 usage
387 ;;
388 *)
389 break
390 ;;
391 esac
392 shift
393 done
394
6e7c14e6 395 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
396}
397
cf419828
JL
398#
399# Unregister submodules from .git/config and remove their work tree
400#
cf419828
JL
401cmd_deinit()
402{
403 # parse $args after "submodule ... deinit".
f6a52799 404 deinit_all=
cf419828
JL
405 while test $# -ne 0
406 do
407 case "$1" in
408 -f|--force)
409 force=$1
410 ;;
411 -q|--quiet)
412 GIT_QUIET=1
413 ;;
f6a52799
SB
414 --all)
415 deinit_all=t
416 ;;
cf419828
JL
417 --)
418 shift
419 break
420 ;;
421 -*)
422 usage
423 ;;
424 *)
425 break
426 ;;
427 esac
428 shift
429 done
430
2e612731 431 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
432}
433
fb43e31f 434is_tip_reachable () (
01e1d544 435 sanitize_submodule_env &&
fb43e31f
SB
436 cd "$1" &&
437 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
438 test -z "$rev"
439)
440
441fetch_in_submodule () (
01e1d544 442 sanitize_submodule_env &&
fb43e31f
SB
443 cd "$1" &&
444 case "$2" in
445 '')
446 git fetch ;;
447 *)
6cbf454a
SB
448 shift
449 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
450 esac
451)
452
70c7ac22 453#
211b7f19 454# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
455#
456# $@ = requested paths (default to all)
457#
23a485e3 458cmd_update()
70c7ac22 459{
5c08dbbd
JH
460 # parse $args after "submodule ... update".
461 while test $# -ne 0
462 do
463 case "$1" in
464 -q|--quiet)
2e6a30ef 465 GIT_QUIET=1
5c08dbbd 466 ;;
72c5f883 467 --progress)
c7199e3a 468 progress=1
72c5f883 469 ;;
be4d2c83 470 -i|--init)
d92a3959 471 init=1
be4d2c83 472 ;;
06b1abb5
TK
473 --remote)
474 remote=1
475 ;;
31ca3ac3 476 -N|--no-fetch)
31ca3ac3
FF
477 nofetch=1
478 ;;
9db31bdf
NMC
479 -f|--force)
480 force=$1
481 ;;
ca2cedba 482 -r|--rebase)
32948425 483 update="rebase"
ca2cedba 484 ;;
d92a3959
MT
485 --reference)
486 case "$2" in '') usage ;; esac
487 reference="--reference=$2"
98dbe63d 488 shift
d92a3959
MT
489 ;;
490 --reference=*)
491 reference="$1"
d92a3959 492 ;;
42b49178 493 -m|--merge)
42b49178
JH
494 update="merge"
495 ;;
b13fd5c1 496 --recursive)
b13fd5c1
JH
497 recursive=1
498 ;;
efc5fb6a
JH
499 --checkout)
500 update="checkout"
501 ;;
abed000a
SB
502 --recommend-shallow)
503 recommend_shallow="--recommend-shallow"
504 ;;
505 --no-recommend-shallow)
506 recommend_shallow="--no-recommend-shallow"
507 ;;
275cd184
FG
508 --depth)
509 case "$2" in '') usage ;; esac
510 depth="--depth=$2"
511 shift
512 ;;
513 --depth=*)
514 depth=$1
515 ;;
2335b870
SB
516 -j|--jobs)
517 case "$2" in '') usage ;; esac
518 jobs="--jobs=$2"
519 shift
520 ;;
521 --jobs=*)
522 jobs=$1
523 ;;
5c08dbbd
JH
524 --)
525 shift
526 break
527 ;;
528 -*)
529 usage
530 ;;
531 *)
532 break
533 ;;
534 esac
98dbe63d 535 shift
5c08dbbd
JH
536 done
537
d92a3959
MT
538 if test -n "$init"
539 then
540 cmd_init "--" "$@" || return
541 fi
542
48308681
SB
543 {
544 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 545 ${progress:+"--progress"} \
48308681
SB
546 ${wt_prefix:+--prefix "$wt_prefix"} \
547 ${prefix:+--recursive-prefix "$prefix"} \
548 ${update:+--update "$update"} \
5f50f33e 549 ${reference:+"$reference"} \
48308681 550 ${depth:+--depth "$depth"} \
c7199e3a
CF
551 $recommend_shallow \
552 $jobs \
c4c02bf1 553 "$@" || echo "#unmatched" $?
48308681 554 } | {
15ffb7cd 555 err=
cf9e55f4 556 while read -r mode sha1 stage just_cloned sm_path
70c7ac22 557 do
c4c02bf1 558 die_if_unmatched "$mode" "$sha1"
48308681 559
0ea306ef 560 name=$(git submodule--helper name "$sm_path") || exit
efc5fb6a
JH
561 if ! test -z "$update"
562 then
563 update_module=$update
564 else
565 update_module=$(git config submodule."$name".update)
a2aed08b
TK
566 if test -z "$update_module"
567 then
568 update_module="checkout"
569 fi
efc5fb6a
JH
570 fi
571
44431df0 572 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 573
48308681 574 if test $just_cloned -eq 1
d851ffb9 575 then
bf2d8246 576 subsha1=
e7b37caf
SB
577 case "$update_module" in
578 merge | rebase | none)
579 update_module=checkout ;;
580 esac
bf2d8246 581 else
14111fc4 582 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 583 git rev-parse --verify HEAD) ||
091a6eb0 584 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 585 fi
211b7f19 586
06b1abb5
TK
587 if test -n "$remote"
588 then
92bbe7cc 589 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
590 if test -z "$nofetch"
591 then
592 # Fetch remote before determining tracking $sha1
6cbf454a 593 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
594 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
595 fi
14111fc4
JK
596 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
597 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 598 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 599 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
600 fi
601
496eeeb1 602 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 603 then
9db31bdf
NMC
604 subforce=$force
605 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 606 if test -z "$subsha1" && test -z "$force"
b9b378a0 607 then
9db31bdf 608 subforce="-f"
b9b378a0 609 fi
31ca3ac3
FF
610
611 if test -z "$nofetch"
612 then
e5f522d6
JL
613 # Run fetch only if $sha1 isn't present or it
614 # is not reachable from a ref.
fb43e31f 615 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 616 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 617 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
618
619 # Now we tried the usual fetch, but $sha1 may
620 # not be reachable from any of the refs
621 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 622 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 623 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
624 fi
625
877449c1 626 must_die_on_failure=
32948425 627 case "$update_module" in
a2aed08b
TK
628 checkout)
629 command="git checkout $subforce -q"
630 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
631 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
632 ;;
32948425
JH
633 rebase)
634 command="git rebase"
091a6eb0
JK
635 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
636 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 637 must_die_on_failure=yes
32948425 638 ;;
42b49178
JH
639 merge)
640 command="git merge"
091a6eb0
JK
641 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
642 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 643 must_die_on_failure=yes
42b49178 644 ;;
6cb5728c
CP
645 !*)
646 command="${update_module#!}"
b08238ac
SB
647 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
648 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
649 must_die_on_failure=yes
650 ;;
32948425 651 *)
a2aed08b 652 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 653 esac
70c7ac22 654
14111fc4 655 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 656 then
ff968f03 657 say "$say_msg"
877449c1
JH
658 elif test -n "$must_die_on_failure"
659 then
ff968f03 660 die_with_status 2 "$die_msg"
15ffb7cd 661 else
ff968f03 662 err="${err};$die_msg"
877449c1 663 continue
15ffb7cd 664 fi
70c7ac22 665 fi
b13fd5c1
JH
666
667 if test -n "$recursive"
668 then
75bf5e60 669 (
44431df0 670 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 671 wt_prefix=
14111fc4 672 sanitize_submodule_env
75bf5e60 673 cd "$sm_path" &&
36141282 674 eval cmd_update
75bf5e60 675 )
15ffb7cd
FG
676 res=$?
677 if test $res -gt 0
678 then
091a6eb0 679 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 680 if test $res -ne 2
15ffb7cd 681 then
ff968f03 682 err="${err};$die_msg"
15ffb7cd
FG
683 continue
684 else
ff968f03 685 die_with_status $res "$die_msg"
15ffb7cd
FG
686 fi
687 fi
b13fd5c1 688 fi
70c7ac22 689 done
15ffb7cd
FG
690
691 if test -n "$err"
692 then
693 OIFS=$IFS
694 IFS=';'
695 for e in $err
696 do
697 if test -n "$e"
698 then
699 echo >&2 "$e"
700 fi
701 done
702 IFS=$OIFS
703 exit 1
704 fi
705 }
70c7ac22
LH
706}
707
28f9af5d
PY
708#
709# Show commit summary for submodules in index or working tree
710#
711# If '--cached' is given, show summary between index and given commit,
712# or between working tree and given commit
713#
714# $@ = [commit (default 'HEAD'),] requested paths (default all)
715#
716cmd_summary() {
f2dc06a3 717 summary_limit=-1
d0f64dd4 718 for_status=
1c244f6e 719 diff_cmd=diff-index
f2dc06a3 720
28f9af5d
PY
721 # parse $args after "submodule ... summary".
722 while test $# -ne 0
723 do
724 case "$1" in
725 --cached)
726 cached="$1"
727 ;;
1c244f6e
JL
728 --files)
729 files="$1"
730 ;;
d0f64dd4
PY
731 --for-status)
732 for_status="$1"
733 ;;
f2dc06a3 734 -n|--summary-limit)
862ae6cd
RS
735 summary_limit="$2"
736 isnumber "$summary_limit" || usage
f2dc06a3
PY
737 shift
738 ;;
862ae6cd
RS
739 --summary-limit=*)
740 summary_limit="${1#--summary-limit=}"
741 isnumber "$summary_limit" || usage
742 ;;
28f9af5d
PY
743 --)
744 shift
745 break
746 ;;
747 -*)
748 usage
749 ;;
750 *)
751 break
752 ;;
753 esac
754 shift
755 done
bffe71f4 756
f2dc06a3
PY
757 test $summary_limit = 0 && return
758
3deea89c 759 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
760 then
761 head=$rev
caa9c3ca 762 test $# = 0 || shift
496eeeb1 763 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 764 then
14e940d7
JH
765 # before the first commit: compare with an empty tree
766 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 767 test -z "$1" || shift
28f9af5d 768 else
3deea89c 769 head="HEAD"
28f9af5d
PY
770 fi
771
1c244f6e
JL
772 if [ -n "$files" ]
773 then
774 test -n "$cached" &&
465d6a00 775 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
776 diff_cmd=diff-files
777 head=
778 fi
779
28f9af5d 780 cd_to_toplevel
091a6eb0 781 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 782 # Get modified modules cared by user
18076502 783 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 784 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 785 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
786 do
787 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
788 if test "$status" = D || test "$status" = T
789 then
6a066230 790 printf '%s\n' "$sm_path"
496eeeb1
EP
791 continue
792 fi
927b26f8 793 # Respect the ignore setting for --for-status.
794 if test -n "$for_status"
795 then
0ea306ef 796 name=$(git submodule--helper name "$sm_path")
927b26f8 797 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 798 test $status != A && test $ignore_config = all && continue
927b26f8 799 fi
28f9af5d 800 # Also show added or modified modules which are checked out
974ce807 801 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 802 printf '%s\n' "$sm_path"
28f9af5d
PY
803 done
804 )
1cb639e6 805
d0f64dd4
PY
806 test -z "$modules" && return
807
18076502 808 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 809 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 810 cut -c2- |
cf9e55f4 811 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
812 do
813 if test -z "$cached" &&
814 test $sha1_dst = 0000000000000000000000000000000000000000
815 then
816 case "$mod_dst" in
817 160000)
818 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
819 ;;
820 100644 | 100755 | 120000)
821 sha1_dst=$(git hash-object $name)
822 ;;
823 000000)
824 ;; # removed
825 *)
826 # unexpected type
6ff875c5 827 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
828 continue ;;
829 esac
830 fi
831 missing_src=
832 missing_dst=
833
834 test $mod_src = 160000 &&
974ce807 835 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
836 missing_src=t
837
838 test $mod_dst = 160000 &&
974ce807 839 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 840 missing_dst=t
bffe71f4 841
44431df0 842 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 843
1cb639e6
PY
844 total_commits=
845 case "$missing_src,$missing_dst" in
846 t,)
091a6eb0 847 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
848 ;;
849 ,t)
091a6eb0 850 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
851 ;;
852 t,t)
091a6eb0 853 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
854 ;;
855 *)
856 errmsg=
857 total_commits=$(
496eeeb1 858 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
859 then
860 range="$sha1_src...$sha1_dst"
861 elif test $mod_src = 160000
862 then
863 range=$sha1_src
864 else
865 range=$sha1_dst
866 fi
867 GIT_DIR="$name/.git" \
b0e621ad 868 git rev-list --first-parent $range -- | wc -l
1cb639e6 869 )
eed35595 870 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
871 ;;
872 esac
873
874 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
875 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
876 if test $status = T
877 then
b3e73449
ÆAB
878 blob="$(gettext "blob")"
879 submodule="$(gettext "submodule")"
1cb639e6
PY
880 if test $mod_dst = 160000
881 then
091a6eb0 882 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 883 else
091a6eb0 884 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
885 fi
886 else
091a6eb0 887 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
888 fi
889 if test -n "$errmsg"
890 then
891 # Don't give error msg for modification whose dst is not submodule
892 # i.e. deleted or changed to blob
893 test $mod_dst = 160000 && echo "$errmsg"
894 else
496eeeb1 895 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 896 then
f2dc06a3
PY
897 limit=
898 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 899 GIT_DIR="$name/.git" \
f2dc06a3 900 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
901 --first-parent $sha1_src...$sha1_dst
902 elif test $mod_dst = 160000
903 then
904 GIT_DIR="$name/.git" \
905 git log --pretty='format: > %s' -1 $sha1_dst
906 else
907 GIT_DIR="$name/.git" \
908 git log --pretty='format: < %s' -1 $sha1_src
909 fi
910 echo
911 fi
912 echo
3ba7407b 913 done
28f9af5d 914}
70c7ac22 915#
941987a5 916# List all submodules, prefixed with:
70c7ac22
LH
917# - submodule not initialized
918# + different revision checked out
919#
920# If --cached was specified the revision in the index will be printed
921# instead of the currently checked out revision.
922#
923# $@ = requested paths (default to all)
924#
23a485e3 925cmd_status()
70c7ac22 926{
5c08dbbd
JH
927 # parse $args after "submodule ... status".
928 while test $# -ne 0
929 do
930 case "$1" in
931 -q|--quiet)
2e6a30ef 932 GIT_QUIET=1
5c08dbbd
JH
933 ;;
934 --cached)
935 cached=1
936 ;;
64b19ffe
JH
937 --recursive)
938 recursive=1
939 ;;
5c08dbbd
JH
940 --)
941 shift
942 break
943 ;;
944 -*)
945 usage
946 ;;
947 *)
948 break
949 ;;
950 esac
951 shift
952 done
953
a9f8a375 954 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 955}
2327f61e
DA
956#
957# Sync remote urls for submodules
958# This makes the value for remote.$remote.url match the value
959# specified in .gitmodules.
960#
961cmd_sync()
962{
963 while test $# -ne 0
964 do
965 case "$1" in
966 -q|--quiet)
2e6a30ef 967 GIT_QUIET=1
2327f61e
DA
968 shift
969 ;;
82f49f29
PH
970 --recursive)
971 recursive=1
972 shift
973 ;;
2327f61e
DA
974 --)
975 shift
976 break
977 ;;
978 -*)
979 usage
980 ;;
981 *)
982 break
983 ;;
984 esac
985 done
e7849a96 986
13424764 987 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 988}
70c7ac22 989
f6f85861
SB
990cmd_absorbgitdirs()
991{
992 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
993}
994
5c08dbbd
JH
995# This loop parses the command line arguments to find the
996# subcommand name to dispatch. Parsing of the subcommand specific
997# options are primarily done by the subcommand implementations.
998# Subcommand specific options such as --branch and --cached are
999# parsed here as well, for backward compatibility.
1000
1001while test $# != 0 && test -z "$command"
70c7ac22
LH
1002do
1003 case "$1" in
f6f85861 1004 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1005 command=$1
70c7ac22
LH
1006 ;;
1007 -q|--quiet)
2e6a30ef 1008 GIT_QUIET=1
70c7ac22 1009 ;;
ecda0723
SV
1010 -b|--branch)
1011 case "$2" in
1012 '')
1013 usage
1014 ;;
1015 esac
1016 branch="$2"; shift
1017 ;;
70c7ac22 1018 --cached)
28f9af5d 1019 cached="$1"
70c7ac22
LH
1020 ;;
1021 --)
1022 break
1023 ;;
1024 -*)
1025 usage
1026 ;;
1027 *)
1028 break
1029 ;;
1030 esac
1031 shift
1032done
1033
5c08dbbd 1034# No command word defaults to "status"
af9c9f97
RR
1035if test -z "$command"
1036then
1037 if test $# = 0
1038 then
1039 command=status
1040 else
1041 usage
1042 fi
1043fi
5c08dbbd
JH
1044
1045# "-b branch" is accepted only by "add"
1046if test -n "$branch" && test "$command" != add
1047then
ecda0723 1048 usage
5c08dbbd
JH
1049fi
1050
28f9af5d 1051# "--cached" is accepted only by "status" and "summary"
496eeeb1 1052if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1053then
70c7ac22 1054 usage
5c08dbbd
JH
1055fi
1056
1057"cmd_$command" "$@"